using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Genghis.Windows.Forms;

namespace WebformValidationTest
{
	/// <summary>
	/// Summary description for AppliedTest.
	/// </summary>
	public class AppliedValidatorTest : System.Windows.Forms.Form
	{
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.Label label3;
        private System.Windows.Forms.Label label6;
        private System.Windows.Forms.Label label7;
        private System.Windows.Forms.Button btnSave;
        private System.Windows.Forms.Button btnCancel;
        private System.Windows.Forms.TextBox txtName;
        private System.Windows.Forms.TextBox txtAddress;
        private System.Windows.Forms.ComboBox cboState;
        private System.Windows.Forms.TextBox txtPhoneNumber;
        private System.Windows.Forms.TextBox txtDOB;
        private Genghis.Windows.Forms.RequiredFieldValidator requiredName;
        private Genghis.Windows.Forms.RequiredFieldValidator requiredAddress;
        private Genghis.Windows.Forms.RequiredFieldValidator requiredState;
        private System.Windows.Forms.Label label4;
        private Genghis.Windows.Forms.RegularExpressionValidator regexPhoneNumber;
        private Genghis.Windows.Forms.CompareValidator compareDOB;
        private Genghis.Windows.Forms.RangeValidator rangeZipCode;
        private System.Windows.Forms.TextBox txtZipCode;
        private System.Windows.Forms.StatusBar statusBar;
        private System.Windows.Forms.StatusBarPanel statusBarPanel1;
        private Genghis.Windows.Forms.UserControl1 ucIncomeRange;
        private Genghis.Windows.Forms.RangeValidator rangeIncome;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public AppliedValidatorTest()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(AppliedValidatorTest));
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.label6 = new System.Windows.Forms.Label();
            this.label7 = new System.Windows.Forms.Label();
            this.txtName = new System.Windows.Forms.TextBox();
            this.txtAddress = new System.Windows.Forms.TextBox();
            this.cboState = new System.Windows.Forms.ComboBox();
            this.txtPhoneNumber = new System.Windows.Forms.TextBox();
            this.txtDOB = new System.Windows.Forms.TextBox();
            this.btnSave = new System.Windows.Forms.Button();
            this.btnCancel = new System.Windows.Forms.Button();
            this.requiredName = new Genghis.Windows.Forms.RequiredFieldValidator();
            this.requiredAddress = new Genghis.Windows.Forms.RequiredFieldValidator();
            this.requiredState = new Genghis.Windows.Forms.RequiredFieldValidator();
            this.regexPhoneNumber = new Genghis.Windows.Forms.RegularExpressionValidator();
            this.compareDOB = new Genghis.Windows.Forms.CompareValidator();
            this.txtZipCode = new System.Windows.Forms.TextBox();
            this.label4 = new System.Windows.Forms.Label();
            this.rangeZipCode = new Genghis.Windows.Forms.RangeValidator();
            this.statusBar = new System.Windows.Forms.StatusBar();
            this.statusBarPanel1 = new System.Windows.Forms.StatusBarPanel();
            this.ucIncomeRange = new Genghis.Windows.Forms.UserControl1();
            this.rangeIncome = new Genghis.Windows.Forms.RangeValidator();
            ((System.ComponentModel.ISupportInitialize)(this.requiredName)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.requiredAddress)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.requiredState)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.regexPhoneNumber)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.compareDOB)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.rangeZipCode)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.statusBarPanel1)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.rangeIncome)).BeginInit();
            this.SuspendLayout();
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(16, 19);
            this.label1.Name = "label1";
            this.label1.TabIndex = 0;
            this.label1.Text = "Name:";
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(16, 47);
            this.label2.Name = "label2";
            this.label2.TabIndex = 1;
            this.label2.Text = "Address:";
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(16, 74);
            this.label3.Name = "label3";
            this.label3.TabIndex = 2;
            this.label3.Text = "State:";
            // 
            // label6
            // 
            this.label6.Location = new System.Drawing.Point(16, 129);
            this.label6.Name = "label6";
            this.label6.TabIndex = 5;
            this.label6.Text = "Phone Number:";
            // 
            // label7
            // 
            this.label7.Location = new System.Drawing.Point(16, 155);
            this.label7.Name = "label7";
            this.label7.TabIndex = 6;
            this.label7.Text = "DOB:";
            // 
            // txtName
            // 
            this.txtName.Location = new System.Drawing.Point(102, 16);
            this.txtName.Name = "txtName";
            this.txtName.Size = new System.Drawing.Size(152, 20);
            this.txtName.TabIndex = 1;
            this.txtName.Text = "";
            this.txtName.Enter += new System.EventHandler(this.txtName_Enter);
            // 
            // txtAddress
            // 
            this.txtAddress.Location = new System.Drawing.Point(102, 44);
            this.txtAddress.Name = "txtAddress";
            this.txtAddress.Size = new System.Drawing.Size(152, 20);
            this.txtAddress.TabIndex = 2;
            this.txtAddress.Text = "";
            this.txtAddress.Enter += new System.EventHandler(this.txtAddress_Enter);
            // 
            // cboState
            // 
            this.cboState.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cboState.Items.AddRange(new object[] {
                                                          "",
                                                          "California",
                                                          "New Mexico",
                                                          "New York",
                                                          "North Dakota",
                                                          "Oregon",
                                                          "South Dakota",
                                                          "Washington"});
            this.cboState.Location = new System.Drawing.Point(102, 71);
            this.cboState.Name = "cboState";
            this.cboState.Size = new System.Drawing.Size(152, 21);
            this.cboState.TabIndex = 3;
            this.cboState.Enter += new System.EventHandler(this.cboState_Enter);
            // 
            // txtPhoneNumber
            // 
            this.txtPhoneNumber.Location = new System.Drawing.Point(102, 126);
            this.txtPhoneNumber.Name = "txtPhoneNumber";
            this.txtPhoneNumber.Size = new System.Drawing.Size(152, 20);
            this.txtPhoneNumber.TabIndex = 5;
            this.txtPhoneNumber.Text = "";
            this.txtPhoneNumber.Enter += new System.EventHandler(this.txtPhoneNumber_Enter);
            // 
            // txtDOB
            // 
            this.txtDOB.Location = new System.Drawing.Point(102, 153);
            this.txtDOB.Name = "txtDOB";
            this.txtDOB.Size = new System.Drawing.Size(152, 20);
            this.txtDOB.TabIndex = 6;
            this.txtDOB.Text = "";
            this.txtDOB.Enter += new System.EventHandler(this.txtDOB_Enter);
            // 
            // btnSave
            // 
            this.btnSave.Location = new System.Drawing.Point(280, 17);
            this.btnSave.Name = "btnSave";
            this.btnSave.TabIndex = 8;
            this.btnSave.Text = "Save";
            this.btnSave.Click += new System.EventHandler(this.btnSave_Click);
            this.btnSave.Enter += new System.EventHandler(this.btnSave_Enter);
            // 
            // btnCancel
            // 
            this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.btnCancel.Location = new System.Drawing.Point(280, 49);
            this.btnCancel.Name = "btnCancel";
            this.btnCancel.TabIndex = 9;
            this.btnCancel.Text = "Cancel";
            this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
            this.btnCancel.Enter += new System.EventHandler(this.btnCancel_Enter);
            // 
            // requiredName
            // 
            this.requiredName.ControlToValidate = this.txtName;
            this.requiredName.ErrorMessage = "Name is required!";
            this.requiredName.HostingForm = this;
            this.requiredName.Icon = ((System.Drawing.Icon)(resources.GetObject("requiredName.Icon")));
            // 
            // requiredAddress
            // 
            this.requiredAddress.ControlToValidate = this.txtAddress;
            this.requiredAddress.ErrorMessage = "Address is required!";
            this.requiredAddress.HostingForm = this;
            this.requiredAddress.Icon = ((System.Drawing.Icon)(resources.GetObject("requiredAddress.Icon")));
            // 
            // requiredState
            // 
            this.requiredState.ControlToValidate = this.cboState;
            this.requiredState.ErrorMessage = "State is required!";
            this.requiredState.HostingForm = this;
            this.requiredState.Icon = ((System.Drawing.Icon)(resources.GetObject("requiredState.Icon")));
            // 
            // regexPhoneNumber
            // 
            this.regexPhoneNumber.ControlToValidate = this.txtPhoneNumber;
            this.regexPhoneNumber.ErrorMessage = "Phone number is not correctly formatted!";
            this.regexPhoneNumber.HostingForm = this;
            this.regexPhoneNumber.Icon = ((System.Drawing.Icon)(resources.GetObject("regexPhoneNumber.Icon")));
            this.regexPhoneNumber.Required = false;
            this.regexPhoneNumber.ValidationExpression = "\\d{3}-\\d{4}";
            // 
            // compareDOB
            // 
            this.compareDOB.ControlToValidate = this.txtDOB;
            this.compareDOB.ErrorMessage = "Must be at least 18 years old!";
            this.compareDOB.HostingForm = this;
            this.compareDOB.Icon = ((System.Drawing.Icon)(resources.GetObject("compareDOB.Icon")));
            this.compareDOB.Operator = Genghis.Windows.Forms.ValidationCompareOperator.LessThanEqual;
            this.compareDOB.Required = false;
            this.compareDOB.Type = Genghis.Windows.Forms.ValidationDataType.Date;
            // 
            // txtZipCode
            // 
            this.txtZipCode.Location = new System.Drawing.Point(102, 99);
            this.txtZipCode.Name = "txtZipCode";
            this.txtZipCode.Size = new System.Drawing.Size(152, 20);
            this.txtZipCode.TabIndex = 4;
            this.txtZipCode.Text = "";
            this.txtZipCode.Enter += new System.EventHandler(this.txtZipCode_Enter);
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(16, 101);
            this.label4.Name = "label4";
            this.label4.TabIndex = 14;
            this.label4.Text = "ZipCode:";
            // 
            // rangeZipCode
            // 
            this.rangeZipCode.ControlToValidate = this.txtZipCode;
            this.rangeZipCode.ErrorMessage = "Zipcode not in range!";
            this.rangeZipCode.HostingForm = this;
            this.rangeZipCode.Icon = ((System.Drawing.Icon)(resources.GetObject("rangeZipCode.Icon")));
            this.rangeZipCode.MaximumValue = "50000";
            this.rangeZipCode.MinimumValue = "30000";
            this.rangeZipCode.Required = false;
            this.rangeZipCode.Type = Genghis.Windows.Forms.ValidationDataType.Integer;
            // 
            // statusBar
            // 
            this.statusBar.Location = new System.Drawing.Point(0, 260);
            this.statusBar.Name = "statusBar";
            this.statusBar.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
                                                                                         this.statusBarPanel1});
            this.statusBar.ShowPanels = true;
            this.statusBar.Size = new System.Drawing.Size(378, 22);
            this.statusBar.SizingGrip = false;
            this.statusBar.TabIndex = 15;
            // 
            // statusBarPanel1
            // 
            this.statusBarPanel1.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
            this.statusBarPanel1.Width = 378;
            // 
            // ucIncomeRange
            // 
            this.ucIncomeRange.BackColor = System.Drawing.SystemColors.Info;
            this.ucIncomeRange.Location = new System.Drawing.Point(102, 184);
            this.ucIncomeRange.Name = "ucIncomeRange";
            this.ucIncomeRange.Size = new System.Drawing.Size(150, 50);
            this.ucIncomeRange.TabIndex = 7;
            this.ucIncomeRange.Enter += new System.EventHandler(this.ucIncomeRange_Enter);
            // 
            // rangeIncome
            // 
            this.rangeIncome.ControlToValidate = this.ucIncomeRange;
            this.rangeIncome.ErrorMessage = "user control dodgy";
            this.rangeIncome.HostingForm = this;
            this.rangeIncome.Icon = ((System.Drawing.Icon)(resources.GetObject("rangeIncome.Icon")));
            this.rangeIncome.MaximumValue = "1000000";
            this.rangeIncome.MinimumValue = "20000";
            this.rangeIncome.Required = false;
            this.rangeIncome.Type = Genghis.Windows.Forms.ValidationDataType.Currency;
            // 
            // AppliedValidatorTest
            // 
            this.AcceptButton = this.btnSave;
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.CancelButton = this.btnCancel;
            this.ClientSize = new System.Drawing.Size(378, 282);
            this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                          this.ucIncomeRange,
                                                                          this.statusBar,
                                                                          this.txtZipCode,
                                                                          this.label4,
                                                                          this.btnCancel,
                                                                          this.btnSave,
                                                                          this.txtDOB,
                                                                          this.txtPhoneNumber,
                                                                          this.cboState,
                                                                          this.txtAddress,
                                                                          this.txtName,
                                                                          this.label7,
                                                                          this.label6,
                                                                          this.label3,
                                                                          this.label2,
                                                                          this.label1});
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.Name = "AppliedValidatorTest";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
            this.Text = "Applied Validator Test";
            this.Load += new System.EventHandler(this.AppliedValidatorTest_Load);
            ((System.ComponentModel.ISupportInitialize)(this.requiredName)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.requiredAddress)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.requiredState)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.regexPhoneNumber)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.compareDOB)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.rangeZipCode)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.statusBarPanel1)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.rangeIncome)).EndInit();
            this.ResumeLayout(false);

        }
		#endregion
		
        #region EventHandlers

        private void AppliedValidatorTest_Load(object sender, System.EventArgs e)        
        {
            compareDOB.ValueToCompare = DateTime.Now.AddYears(-18).ToString("dd/MM/yyyy");
        }
    
        private void btnSave_Click(object sender, System.EventArgs e)
        {
            // Further form-wide validation to manually check
            // the validity of your form fields
            FormValidator.GetFormValidator(this).Validate();
            if( FormValidator.GetFormValidator(this).IsValid )
            {
                MessageBox.Show("Success");
                Close();
            }
        }

        private void btnCancel_Click(object sender, System.EventArgs e)
        {
            Close();
        }

        private void txtName_Enter(object sender, System.EventArgs e)
        {
            statusBar.Panels[0].Text = "Name Validation: Required Field Validator";
        }

        private void txtAddress_Enter(object sender, System.EventArgs e)
        {
            statusBar.Panels[0].Text = "Address Validation: Required Field Validator";
        }

        private void cboState_Enter(object sender, System.EventArgs e)
        {
            statusBar.Panels[0].Text = "State Validation: Required Field Validator";
        }

        private void txtZipCode_Enter(object sender, System.EventArgs e)
        {
            statusBar.Panels[0].Text = "ZipCode Validation: Range Validator (30000-50000)";
        }

        private void txtPhoneNumber_Enter(object sender, System.EventArgs e)
        {
            statusBar.Panels[0].Text = "Phone Number Validation: Regex Validator (Must look like 123-4567)";
        }

        private void txtDOB_Enter(object sender, System.EventArgs e)
        {
            statusBar.Panels[0].Text = "DOB Validation: Compare Validator (Must be at least 18 years old)";
        }

        private void ucIncomeRange_Enter(object sender, System.EventArgs e)
        {
            statusBar.Panels[0].Text = "Income Validation: Range Validator ($20000 to $1000000)";
        }
        
        private void btnSave_Enter(object sender, System.EventArgs e)
        {
            statusBar.Panels[0].Text = "";
        }

        private void btnCancel_Enter(object sender, System.EventArgs e)
        {
            statusBar.Panels[0].Text = "";
        }
        
        #endregion
	}
}
