// AssemblyInfo.cs
#region Copyright  2002-2003 The Genghis Group
/*
 * This software is provided 'as-is', without any express or implied warranty.
 * In no event will the authors be held liable for any damages arising from the
 * use of this software.
 * 
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, subject to the following restrictions:
 * 
 * 1. The origin of this software must not be misrepresented; you must not claim
 * that you wrote the original software. If you use this software in a product,
 * an acknowledgment in the product documentation is required, as shown here:
 * 
 * Portions Copyright  2002-2003 The Genghis Group (http://www.genghisgroup.com/).
 * 
 * 2. No substantial portion of the source code of this library may be redistributed
 * without the express written permission of the copyright holders, where
 * "substantial" is defined as enough code to be recognizably from this library. 
*/
#endregion

using System;
using System.Reflection;
using System.Runtime.CompilerServices;

// Of course, we have to be CLS compliant -- that's the whole point...
[assembly: CLSCompliant(true)]

[assembly: AssemblyTitle("Genghis")]
[assembly: AssemblyDescription("An application framework for .NET")]
[assembly: AssemblyConfiguration("")]
[assembly: AssemblyCompany("The Genghis Group")]
[assembly: AssemblyProduct("Genghis")]
[assembly: AssemblyCopyright("Copyright  2002-2003, The Genghis Group")]
[assembly: AssemblyTrademark("")]
[assembly: AssemblyCulture("")]

[assembly: AssemblyVersion("0.4.*")]

// NOTE: To use genghis as an assembly, either use the pre-built
// genghis.dll that has been signed, register genghis.dll for
// verification skipping (via 'sn -Vr') or sign it with your
// own key (via 'sn -R')
[assembly: AssemblyKeyFile(@"..\..\genghispub.key")]
[assembly: AssemblyDelaySign(true)]
